searchData={"items":[{"type":"behaviour","title":"JetExt.Absinthe.ErrorHandler","doc":"Absinthe error handlers can handle more data types as an error when works\nwith `JetExt.Absinthe.Middleware.HandleError`.","ref":"JetExt.Absinthe.ErrorHandler.html"},{"type":"callback","title":"JetExt.Absinthe.ErrorHandler.handle/1","doc":"This is the main callback of an error handler.\n\nIt accepts any type of error and returns a `{:ok, term}` tuple if the error\ncan be handled, otherwise it returns `:error`.","ref":"JetExt.Absinthe.ErrorHandler.html#c:handle/1"},{"type":"module","title":"JetExt.Absinthe.ErrorHandler.Default","doc":"The default error handler for `JetExt.Absinthe.Middleware.HandleError` that handles ecto\nchangeset as an error.\n\nIf the `PolymorphicEmbed` module is loaded, it will use the `traverse_errors` function from it,\notherwise it will use the `traverse_errors` function from `Ecto.Changeset`.","ref":"JetExt.Absinthe.ErrorHandler.Default.html"},{"type":"module","title":"JetExt.Absinthe.Middleware.HandleError","doc":"Absinthe Middleware to support more types of error.\n\nThe operating logic of error handlers is in the form of fallback,\nand each error is handled by at most one handler.\n\nIt can be configured with:\n\n  config :jext_ext, Absinthe,\n    error_handlers: [JetExt.Absinthe.ErrorHandler.Default, MyHanler]","ref":"JetExt.Absinthe.Middleware.HandleError.html"},{"type":"module","title":"JetExt.Absinthe.OneOf","doc":"The homemade `one_of` directive for Absinthe.","ref":"JetExt.Absinthe.OneOf.html"},{"type":"module","title":"使用方法 - JetExt.Absinthe.OneOf","doc":"1. 参考 `JetExt.Absinthe.OneOf.Phase` 的文档，将 phase 加入到 absinthe 的 phases 中\n2. 参考 `JetExt.Absinthe.OneOf.SchemaProtoType` 的文档，在你的 absinthe schema 引入 `:one_of` directive\n3. 参考 `JetExt.Absinthe.OneOf.Middleware.InputModifier` 的文档，用 `:one_of` 来定义你的 input_object\n4. `JetExt.Absinthe.OneOf.Helpers` 目前提供了一个 `fold_key_to_field/3`，一个使用案例参考 3 中的例子","ref":"JetExt.Absinthe.OneOf.html#module-%E4%BD%BF%E7%94%A8%E6%96%B9%E6%B3%95"},{"type":"module","title":"JetExt.Absinthe.OneOf.Helpers","doc":"The helpers for `JetExt.Absinthe.OneOf`.","ref":"JetExt.Absinthe.OneOf.Helpers.html"},{"type":"function","title":"JetExt.Absinthe.OneOf.Helpers.fold_key_to_field/3","doc":"","ref":"JetExt.Absinthe.OneOf.Helpers.html#fold_key_to_field/3"},{"type":"function","title":"JetExt.Absinthe.OneOf.Helpers.unwrap_data/1","doc":"","ref":"JetExt.Absinthe.OneOf.Helpers.html#unwrap_data/1"},{"type":"function","title":"JetExt.Absinthe.OneOf.Helpers.unwrap_input_object/1","doc":"","ref":"JetExt.Absinthe.OneOf.Helpers.html#unwrap_input_object/1"},{"type":"module","title":"JetExt.Absinthe.OneOf.Middleware.InputModifier","doc":"Modify the input object.","ref":"JetExt.Absinthe.OneOf.Middleware.InputModifier.html"},{"type":"module","title":"使用方法 - JetExt.Absinthe.OneOf.Middleware.InputModifier","doc":"```elixir\ndefmodule MyApp.GraphQL.Schema.Admin do\n  @moduledoc false\n\n  use Absinthe.Schema.Notation\n  use Absinthe.Relay.Schema.Notation, :modern\n\n  alias Absinthe.Blueprint.Input\n  alias JetExt.Absinthe.OneOf.Helpers\n\n  input_object :user_input do\n    # 首先启用 :one_of directive\n    directive :one_of\n\n    # 使用 Helpers 提供的 input_modifier\n    private(\n      :input_modifier,\n      :with,\n      {Helpers, :fold_key_to_field, [:__type__]}\n    )\n\n    field :plain_user, :plain_user_input\n    field :admin, :admin_input\n  end\n\n  input_object :plain_user_input do\n    field :username, non_null(:string)\n  end\n\n  input_object :admin_input do\n    field :role, non_null(:string)\n  end\n\n  object :mutations do\n    payload field(:create_user) do\n      input do\n        field :attributes, non_null(list_of(non_null(:user_input)))\n      end\n\n      output do\n        field :attributes, non_null(list_of(non_null(:user)))\n      end\n\n      # 在 input 使用了 one_of 后，再启用本 middleware\n      middleware JetExt.Absinthe.OneOf.Middleware.InputModifier\n\n      resolve &create_user/2\n    end\n  end\n\n  defp create_user(args, _resolution) do\n    IO.inspect(args)\n    # 前端会这样调用：\n    # mutation {\n    #   createUser(input: {\n    #     plainUser: { username: \"foo\" }\n    #   }) {\n    #     id\n    #   }\n    # }\n    #\n    # 我们这里拿到的 args 是（注意 plain_user 是从驼峰转成了蛇底的）：\n    # %{\n    #   username: \"foo\",\n    #   \"__type__\": \"plain_user\"\n    # }\n  end\nend\n```","ref":"JetExt.Absinthe.OneOf.Middleware.InputModifier.html#module-%E4%BD%BF%E7%94%A8%E6%96%B9%E6%B3%95"},{"type":"module","title":"JetExt.Absinthe.OneOf.Phase","doc":"The homemade `one_of` phase for Absinthe.","ref":"JetExt.Absinthe.OneOf.Phase.html"},{"type":"module","title":"使用方法 - JetExt.Absinthe.OneOf.Phase","doc":"在 Router 中添加如下代码：\n```elixir\ndefmodule MyApp.Router do\n  use Phoenix.Router\n\n  # ...\n\n  scope \"/api\" do\n    pipe_through :api\n\n    forward \"/admin/explorer\", Absinthe.Plug.GraphiQL,\n      interface: :playground,\n      schema: MyApp.GraphQL.Schema.Admin,\n      # 添加下面这一行\n      pipeline: {__MODULE__, :pipeline}\n\n    forward \"/admin\", Absinthe.Plug,\n      json_codec: Jason,\n      schema: MyApp.GraphQL.Schema.Admin,\n      # 添加下面这一行\n      pipeline: {__MODULE__, :pipeline}\n  end\n\n  @spec pipeline(map(), keyword()) :: Absinthe.Pipeline.t()\n  def pipeline(config, opts) do\n    config.schema_mod\n    |> Absinthe.Pipeline.for_document(opts)\n    |> Absinthe.Pipeline.insert_after(\n      Absinthe.Phase.Document.Validation.OnlyOneSubscription,\n      JetExt.Absinthe.OneOf.Phase\n    )\n  end\nend\n```","ref":"JetExt.Absinthe.OneOf.Phase.html#module-%E4%BD%BF%E7%94%A8%E6%96%B9%E6%B3%95"},{"type":"module","title":"开发笔记 - JetExt.Absinthe.OneOf.Phase","doc":"参考：https://maartenvanvliet.nl/2022/04/28/absinthe_input_union/\n他的方案只能校验最上层的 input_object 的 one_of，因此做了修改能够递归地校验 input_object 下层的 one_of。","ref":"JetExt.Absinthe.OneOf.Phase.html#module-%E5%BC%80%E5%8F%91%E7%AC%94%E8%AE%B0"},{"type":"module","title":"JetExt.Absinthe.OneOf.SchemaProtoType","doc":"The homemade `one_of` directive.","ref":"JetExt.Absinthe.OneOf.SchemaProtoType.html"},{"type":"module","title":"使用方法 - JetExt.Absinthe.OneOf.SchemaProtoType","doc":"在你的 schema 中添加下面代码：\n```elixir\ndefmodule MyApp.Schema.Admin do\n  use Absinthe.Schema\n\n  # 添加这一行\n  @prototype_schema JetExt.Absinthe.OneOf.SchemaProtoType\n\n  # ...\nend\n```","ref":"JetExt.Absinthe.OneOf.SchemaProtoType.html#module-%E4%BD%BF%E7%94%A8%E6%96%B9%E6%B3%95"},{"type":"function","title":"JetExt.Absinthe.OneOf.SchemaProtoType.expand_deprecate/2","doc":"Add a deprecation (with an optional reason) to a node.","ref":"JetExt.Absinthe.OneOf.SchemaProtoType.html#expand_deprecate/2"},{"type":"function","title":"JetExt.Absinthe.OneOf.SchemaProtoType.pipeline/1","doc":"","ref":"JetExt.Absinthe.OneOf.SchemaProtoType.html#pipeline/1"},{"type":"protocol","title":"JetExt.Absinthe.Relay.Connection.FieldType","doc":"","ref":"JetExt.Absinthe.Relay.Connection.FieldType.html"},{"type":"function","title":"JetExt.Absinthe.Relay.Connection.FieldType.get_type/2","doc":"Get the field type for a field of a queryable.","ref":"JetExt.Absinthe.Relay.Connection.FieldType.html#get_type/2"},{"type":"type","title":"JetExt.Absinthe.Relay.Connection.FieldType.t/0","doc":"","ref":"JetExt.Absinthe.Relay.Connection.FieldType.html#t:t/0"},{"type":"module","title":"JetExt.Absinthe.Relay.Node.Notation","doc":"Macros used to define Node-related schema entities\n\nSee `Absinthe.Relay.Node` for examples of use.\n\nIf you wish to use this module on its own without `use Absinthe.Relay` you\nneed to include\n```\n@pipeline_modifier Absinthe.Relay.Schema\n```\nin your root schema module.","ref":"JetExt.Absinthe.Relay.Node.Notation.html"},{"type":"function","title":"JetExt.Absinthe.Relay.Node.Notation.additional_types/2","doc":"","ref":"JetExt.Absinthe.Relay.Node.Notation.html#additional_types/2"},{"type":"function","title":"JetExt.Absinthe.Relay.Node.Notation.fillout/2","doc":"","ref":"JetExt.Absinthe.Relay.Node.Notation.html#fillout/2"},{"type":"macro","title":"JetExt.Absinthe.Relay.Node.Notation.node/2","doc":"Define a node interface, field, or object type for a schema.\n\nSee the `Absinthe.Relay.Node` module documentation for examples.","ref":"JetExt.Absinthe.Relay.Node.Notation.html#node/2"},{"type":"function","title":"JetExt.Absinthe.Relay.Node.Notation.resolve_with_global_id/2","doc":"","ref":"JetExt.Absinthe.Relay.Node.Notation.html#resolve_with_global_id/2"},{"type":"module","title":"JetExt.Absinthe.Relay.Schema","doc":"Used to extend a schema with Relay-specific macros and types.\n\nSee `Absinthe.Relay`.","ref":"JetExt.Absinthe.Relay.Schema.html"},{"type":"function","title":"JetExt.Absinthe.Relay.Schema.pipeline/1","doc":"","ref":"JetExt.Absinthe.Relay.Schema.html#pipeline/1"},{"type":"module","title":"JetExt.Absinthe.Relay.Schema.Notation","doc":"Used to extend a module where Absinthe types are defined with\nRelay-specific macros and types.\n\nSee `Absinthe.Relay`.","ref":"JetExt.Absinthe.Relay.Schema.Notation.html"},{"type":"type","title":"JetExt.Absinthe.Relay.Schema.Notation.flavor/0","doc":"A valid flavor","ref":"JetExt.Absinthe.Relay.Schema.Notation.html#t:flavor/0"},{"type":"module","title":"JetExt.Absinthe.Types.Scalar.CamelizedObjectJSON","doc":"Serialized object JSON value.","ref":"JetExt.Absinthe.Types.Scalar.CamelizedObjectJSON.html"},{"type":"module","title":"JetExt.Absinthe.Types.Scalar.UUID","doc":"The UUID scalar type represents a version 4(random) UUID.\nAny binary not conforming to this format will be flagged.","ref":"JetExt.Absinthe.Types.Scalar.UUID.html"},{"type":"module","title":"JetExt.Config.Env","doc":"This module is used to get environment variables.\n\nThe most common use case is to import this module in config files.","ref":"JetExt.Config.Env.html"},{"type":"module","title":"Example - JetExt.Config.Env","doc":"# runtime.exs\n    import Config\n    import JetExt.Config.Env\n\n    config :some_app,\n      string: fetch_string!(\"STRING_ENV\"),\n      integer: fetch_integer!(\"INTEGER_ENV\")","ref":"JetExt.Config.Env.html#module-example"},{"type":"function","title":"JetExt.Config.Env.cast_boolean/1","doc":"Casts an environment variable to a boolean.\n\nAny string except `\"false\"` and `\"0\"` will be cast to `true`.\nHere are some truthy values: `\"true\"`, `\"1\"`, `\"yes\"`, `\"on\"`.","ref":"JetExt.Config.Env.html#cast_boolean/1"},{"type":"function","title":"JetExt.Config.Env.fetch_integer!/2","doc":"Fetches an environment variable and parses it to an integer.\n\nOptions:\n- default: the default value to return if the environment variable is missing\n- hint: a hint to be used in the error message,\nit can contain `%{name}` which will be replaced by the environment variable name","ref":"JetExt.Config.Env.html#fetch_integer!/2"},{"type":"function","title":"JetExt.Config.Env.fetch_string!/2","doc":"Fetches an environment variable and returns it as a string.\n\nOptions:\n- default: the default value to return if the environment variable is missing\n- hint: a hint to be used in the error message,\nit can contain `%{name}` which will be replaced by the environment variable name","ref":"JetExt.Config.Env.html#fetch_string!/2"},{"type":"type","title":"JetExt.Config.Env.options/0","doc":"","ref":"JetExt.Config.Env.html#t:options/0"},{"type":"module","title":"JetExt.Ecto.Enum","doc":"Defining an Enum Ecto type.","ref":"JetExt.Ecto.Enum.html"},{"type":"module","title":"Parameterized Type - JetExt.Ecto.Enum","doc":"```elixir\n  iex> type = Ecto.ParameterizedType.init(JetExt.Ecto.Enum, values: [:foo, :bar])\n  {\n    :parameterized,\n    JetExt.Ecto.Enum,\n    %{\n      mappings: [foo: \"foo\", bar: \"bar\"],\n      on_cast: %{\"FOO\" => :foo, \"BAR\" => :bar, \"foo\" => :foo, \"bar\" => :bar},\n      on_dump: %{foo: \"FOO\", bar: \"BAR\"},\n      on_load: %{\"FOO\" => :foo, \"BAR\" => :bar},\n      type: :string\n    }\n  }\n  ```","ref":"JetExt.Ecto.Enum.html#module-parameterized-type"},{"type":"module","title":"Type Module - JetExt.Ecto.Enum","doc":"```elixir\n  defmodule EnumType do\n    use JetExt.Ecto.Enum, [:foo, :bar, :baz]\n  end\n  ```\n\n    # cast\n    iex> EnumType.cast(\"foo\")\n    {:ok, :foo}\n    iex> EnumType.cast(\"FOO\")\n    {:ok, :foo}\n    iex> EnumType.cast(:foo)\n    {:ok, :foo}\n\n    # load\n    iex> EnumType.load(\"foo\")\n    {:ok, :foo}\n    iex> EnumType.load(\"FOO\")\n    {:ok, :foo}\n\n    # dump\n    iex> EnumType.dump(:foo)\n    {:ok, \"FOO\"}","ref":"JetExt.Ecto.Enum.html#module-type-module"},{"type":"function","title":"JetExt.Ecto.Enum.dump_values/2","doc":"Returns the possible dump values for a given schema and field","ref":"JetExt.Ecto.Enum.html#dump_values/2"},{"type":"function","title":"JetExt.Ecto.Enum.mappings/2","doc":"Returns the mappings for a given schema and field","ref":"JetExt.Ecto.Enum.html#mappings/2"},{"type":"function","title":"JetExt.Ecto.Enum.values/2","doc":"Returns the possible values for a given schema and field","ref":"JetExt.Ecto.Enum.html#values/2"},{"type":"type","title":"JetExt.Ecto.Enum.t/0","doc":"","ref":"JetExt.Ecto.Enum.html#t:t/0"},{"type":"module","title":"JetExt.Ecto.STI","doc":"The parameterized STI type.\n\n```\n  field :bar, JetExt.Ecto.STI, intermediate_module: MyIntermediaModule\n```","ref":"JetExt.Ecto.STI.html"},{"type":"function","title":"JetExt.Ecto.STI.intermediate_module/2","doc":"","ref":"JetExt.Ecto.STI.html#intermediate_module/2"},{"type":"type","title":"JetExt.Ecto.STI.t/0","doc":"","ref":"JetExt.Ecto.STI.html#t:t/0"},{"type":"module","title":"JetExt.Ecto.STI.Builder","doc":"Defines the STI like Ecto types.","ref":"JetExt.Ecto.STI.Builder.html"},{"type":"module","title":"JetExt.Ecto.STI.Changeset","doc":"Changeset utils for STI.","ref":"JetExt.Ecto.STI.Changeset.html"},{"type":"function","title":"JetExt.Ecto.STI.Changeset.collect_errors/1","doc":"","ref":"JetExt.Ecto.STI.Changeset.html#collect_errors/1"},{"type":"function","title":"JetExt.Ecto.STI.Changeset.validate_change/3","doc":"","ref":"JetExt.Ecto.STI.Changeset.html#validate_change/3"},{"type":"type","title":"JetExt.Ecto.STI.Changeset.sti_errors/0","doc":"","ref":"JetExt.Ecto.STI.Changeset.html#t:sti_errors/0"},{"type":"behaviour","title":"JetExt.Ecto.STI.IntermediateModule","doc":"A behaviour module for implementing a STI Ecto type.","ref":"JetExt.Ecto.STI.IntermediateModule.html"},{"type":"callback","title":"JetExt.Ecto.STI.IntermediateModule.cast/1","doc":"","ref":"JetExt.Ecto.STI.IntermediateModule.html#c:cast/1"},{"type":"callback","title":"JetExt.Ecto.STI.IntermediateModule.dump/1","doc":"","ref":"JetExt.Ecto.STI.IntermediateModule.html#c:dump/1"},{"type":"callback","title":"JetExt.Ecto.STI.IntermediateModule.load/1","doc":"","ref":"JetExt.Ecto.STI.IntermediateModule.html#c:load/1"},{"type":"module","title":"JetExt.Ecto.URI","doc":"An Ecto type for URI ([RFC 3986](https://tools.ietf.org/html/rfc3986)).","ref":"JetExt.Ecto.URI.html"},{"type":"module","title":"Examples - JetExt.Ecto.URI","doc":"# cast\n    iex> cast(\"https://elixir-lang.org/\")\n    {:ok, %URI{\n      fragment: nil,\n      host: \"elixir-lang.org\",\n      path: \"/\",\n      port: 443,\n      query: nil,\n      scheme: \"https\",\n      userinfo: nil\n    }}\n\n    iex> cast(\"/foo\")\n    {:ok, %URI{\n      fragment: nil,\n      host: nil,\n      path: \"/foo\",\n      port: nil,\n      query: nil,\n      scheme: nil,\n      userinfo: nil\n    }}\n\n    iex> cast(:foo)\n    :error\n\n    iex> cast(\"/invalid_greater_than_in_path/>\")\n    {:error, part: \">\"}\n\n    # load\n    iex> load(\"https://elixir-lang.org/\")\n    {:ok, %URI{\n      fragment: nil,\n      host: \"elixir-lang.org\",\n      path: \"/\",\n      port: 443,\n      query: nil,\n      scheme: \"https\",\n      userinfo: nil\n    }}\n\n    iex> load(URI.new!(\"https://elixir-lang.org/\"))\n    {:ok, %URI{\n      fragment: nil,\n      host: \"elixir-lang.org\",\n      path: \"/\",\n      port: 443,\n      query: nil,\n      scheme: \"https\",\n      userinfo: nil\n    }}\n\n    iex> load(%{})\n    :error\n\n    iex> load(:path)\n    :error\n\n    # dump\n\n    iex> dump(URI.new!(\"https://elixir-lang.org/\"))\n    {:ok, \"https://elixir-lang.org/\"}\n\n    iex> dump(%{})\n    :error\n\n    iex> dump(:path)\n    :error","ref":"JetExt.Ecto.URI.html#module-examples"},{"type":"type","title":"JetExt.Ecto.URI.t/0","doc":"","ref":"JetExt.Ecto.URI.html#t:t/0"},{"type":"module","title":"JetExt.Ecto.URN","doc":"An Ecto type for URN ([RFC 8141](https://tools.ietf.org/html/rfc8141))","ref":"JetExt.Ecto.URN.html"},{"type":"module","title":"Examples - JetExt.Ecto.URN","doc":"# cast\n    iex> cast(\"urn:ietf:params:scim:schemas:extension:enterprise:2.0:User:userName\")\n    {:ok, %URN{\n      nid: \"ietf\",\n      nss: \"params:scim:schemas:extension:enterprise:2.0:User:userName\"\n    }}\n\n    iex> cast(:foo)\n    :error\n\n    iex> cast(\"ur:nid:nss\")\n    :error\n\n    # load\n    iex> load(\"urn:ietf:params:scim:schemas:extension:enterprise:2.0:User:userName\")\n    {:ok, %URN{\n      nid: \"ietf\",\n      nss: \"params:scim:schemas:extension:enterprise:2.0:User:userName\"\n    }}\n\n    iex> load(URN.parse!(\"urn:ietf:params:scim:schemas:extension:enterprise:2.0:User:userName\"))\n    {:ok, %URN{\n      nid: \"ietf\",\n      nss: \"params:scim:schemas:extension:enterprise:2.0:User:userName\"\n    }}\n\n    iex> load(%{})\n    :error\n\n    iex> load(:path)\n    :error\n\n    # dump\n\n    iex> dump(URN.parse!(\"urn:ietf:params:scim:schemas:extension:enterprise:2.0:User:userName\"))\n    {:ok, \"urn:ietf:params:scim:schemas:extension:enterprise:2.0:User:userName\"}\n\n    iex> dump(%{})\n    :error\n\n    iex> dump(:path)\n    :error","ref":"JetExt.Ecto.URN.html#module-examples"},{"type":"type","title":"JetExt.Ecto.URN.t/0","doc":"","ref":"JetExt.Ecto.URN.html#t:t/0"},{"type":"module","title":"JetExt.Ecto.Varchar","doc":"An Ecto type for PostgreSQL varchar with limit.","ref":"JetExt.Ecto.Varchar.html"},{"type":"module","title":"Options - JetExt.Ecto.Varchar","doc":"* `:limit` - the length must be less than or equal to this value (default is 255)\n  * `:count` - what length to count for string, `:graphemes` (default) or `:bytes`","ref":"JetExt.Ecto.Varchar.html#module-options"},{"type":"module","title":"Example - JetExt.Ecto.Varchar","doc":"```\nfield :name, JetExt.Ecto.Varchar, limit: 255\n\nfield :name, JetExt.Ecto.Varchar, limit: 255, count: :bytes\n```","ref":"JetExt.Ecto.Varchar.html#module-example"},{"type":"type","title":"JetExt.Ecto.Varchar.t/0","doc":"","ref":"JetExt.Ecto.Varchar.html#t:t/0"},{"type":"module","title":"JetExt.Ecto.Version","doc":"A Ecto Type for `Version` that follows [SemVer 2.0](https://semver.org/).","ref":"JetExt.Ecto.Version.html"},{"type":"module","title":"Examples - JetExt.Ecto.Version","doc":"# cast\n    iex> cast(\"2.0.1-alpha1\")\n    {:ok, %Version{\n      major: 2,\n      minor: 0,\n      patch: 1,\n      pre: [\"alpha1\"]\n    }}\n\n    iex> cast(Version.parse!(\"2.0.1-alpha1\"))\n    {:ok, %Version{\n      major: 2,\n      minor: 0,\n      patch: 1,\n      pre: [\"alpha1\"]\n    }}\n\n    iex> cast(\"1\")\n    :error\n\n    iex> cast(:foo)\n    :error\n\n    # load\n    iex> load(\"2.0.1-alpha1\")\n    {:ok, %Version{\n      major: 2,\n      minor: 0,\n      patch: 1,\n      pre: [\"alpha1\"]\n    }}\n\n    iex> load(Version.parse!(\"2.0.1-alpha1\"))\n    {:ok, %Version{\n      major: 2,\n      minor: 0,\n      patch: 1,\n      pre: [\"alpha1\"]\n    }}\n\n    iex> load(\"1\")\n    :error\n\n    iex> load(:foo)\n    :error\n\n    # dump\n\n    iex> dump(Version.parse!(\"2.0.1-alpha1\"))\n    {:ok, \"2.0.1-alpha1\"}\n\n    iex> dump(%{})\n    :error\n\n    iex> dump(:foo)\n    :error","ref":"JetExt.Ecto.Version.html#module-examples"},{"type":"function","title":"JetExt.Ecto.Version.embed_as/1","doc":"","ref":"JetExt.Ecto.Version.html#embed_as/1"},{"type":"function","title":"JetExt.Ecto.Version.equal?/2","doc":"","ref":"JetExt.Ecto.Version.html#equal?/2"},{"type":"module","title":"JetExt.Map","doc":"This module introduces some useful functions to `Map`.","ref":"JetExt.Map.html"},{"type":"function","title":"JetExt.Map.atomize_keys/1","doc":"Atomize keys of map.","ref":"JetExt.Map.html#atomize_keys/1"},{"type":"function","title":"Example - JetExt.Map.atomize_keys/1","doc":"iex> JetExt.Map.atomize_keys(%{\"a\" => 1, \"b\" => 2})\n    %{a: 1, b: 2}\n    iex> JetExt.Map.atomize_keys(%{\"a\" => 1, \"b\" => %{\"c\" => 2}})\n    %{a: 1, b: %{\"c\" => 2}}\n    iex> JetExt.Map.atomize_keys(%{\"a\" => 1, \"b\" => [%{\"c\" => 2}, %{\"d\" => 3}]})\n    %{a: 1, b: [%{\"c\" => 2}, %{\"d\" => 3}]}","ref":"JetExt.Map.html#atomize_keys/1-example"},{"type":"function","title":"JetExt.Map.fetch/2","doc":"Fetches the value in form of key tuple for a specific key in the given map.","ref":"JetExt.Map.html#fetch/2"},{"type":"function","title":"Example - JetExt.Map.fetch/2","doc":"iex> JetExt.Map.fetch(%{a: 1, b: nil}, :a)\n    {:a, {:ok, 1}}\n    iex> JetExt.Map.fetch(%{a: 1, b: nil}, :b)\n    {:b, {:ok, nil}}\n    iex> JetExt.Map.fetch(%{a: 1, b: nil}, :c)\n    {:c, :error}","ref":"JetExt.Map.html#fetch/2-example"},{"type":"function","title":"JetExt.Map.filter/2","doc":"Filter items of the map.","ref":"JetExt.Map.html#filter/2"},{"type":"function","title":"Example - JetExt.Map.filter/2","doc":"iex> JetExt.Map.filter(%{a: 1, b: 2, c: 3, d: 4}, fn {key, value} -> :a === key or 2 === value end)\n    %{a: 1, b: 2}","ref":"JetExt.Map.html#filter/2-example"},{"type":"function","title":"JetExt.Map.indifferent_fetch/2","doc":"Indifferent access, or return `:error`.","ref":"JetExt.Map.html#indifferent_fetch/2"},{"type":"function","title":"Example - JetExt.Map.indifferent_fetch/2","doc":"iex> JetExt.Map.indifferent_fetch(%{a: 1}, :a)\n    {:ok, 1}\n\n    iex> JetExt.Map.indifferent_fetch(%{\"a\" => 1}, :a)\n    {:ok, 1}\n\n    iex> JetExt.Map.indifferent_fetch(%{\"a\" => 1}, :b)\n    :error","ref":"JetExt.Map.html#indifferent_fetch/2-example"},{"type":"function","title":"JetExt.Map.indifferent_fetch!/2","doc":"Indifferent access, or raise error.","ref":"JetExt.Map.html#indifferent_fetch!/2"},{"type":"function","title":"Example - JetExt.Map.indifferent_fetch!/2","doc":"iex> JetExt.Map.indifferent_fetch!(%{a: 1}, :a)\n    1\n\n    iex> JetExt.Map.indifferent_fetch!(%{\"a\" => 1}, :a)\n    1\n\n    iex> JetExt.Map.indifferent_fetch!(%{\"a\" => 1}, :b)\n    ** (KeyError) key :b not found in: %{\"a\" => 1}","ref":"JetExt.Map.html#indifferent_fetch!/2-example"},{"type":"function","title":"JetExt.Map.indifferent_get/3","doc":"Indifferent access, or return default value.","ref":"JetExt.Map.html#indifferent_get/3"},{"type":"function","title":"Example - JetExt.Map.indifferent_get/3","doc":"iex> JetExt.Map.indifferent_get(%{a: 1}, :a)\n    1\n\n    iex> JetExt.Map.indifferent_get(%{\"a\" => 1}, :a)\n    1\n\n    iex> JetExt.Map.indifferent_get(%{\"a\" => 1}, :b)\n    nil\n\n    iex> JetExt.Map.indifferent_get(%{\"a\" => 1}, :b, 2)\n    2\n\n    iex> JetExt.Map.indifferent_get(%{\"a\" => 1}, \"a\")\n    1","ref":"JetExt.Map.html#indifferent_get/3-example"},{"type":"function","title":"JetExt.Map.indifferent_has_key/2","doc":"Indifferent updates the key in map with the given function.","ref":"JetExt.Map.html#indifferent_has_key/2"},{"type":"function","title":"Example - JetExt.Map.indifferent_has_key/2","doc":"iex> JetExt.Map.indifferent_has_key(%{a: 1}, :a)\n    {:ok, :a}\n\n    iex> JetExt.Map.indifferent_has_key(%{\"a\" => 1}, :a)\n    {:ok, \"a\"}\n\n    iex> JetExt.Map.indifferent_has_key(%{\"a\" => 1}, :b)\n    :error","ref":"JetExt.Map.html#indifferent_has_key/2-example"},{"type":"function","title":"JetExt.Map.indifferent_take/2","doc":"Indifferent take.\n\nReturns a new map with all the key-value pairs in map where the key, or String.to_atom(key) is in keys.","ref":"JetExt.Map.html#indifferent_take/2"},{"type":"function","title":"Example - JetExt.Map.indifferent_take/2","doc":"iex> JetExt.Map.indifferent_take(%{\"a\" => 1, \"b\" => 2, c: 3, d: 4}, [:a, :b, :c])\n    %{a: 1, b: 2, c: 3}\n\n    iex> JetExt.Map.indifferent_take(%{\"a\" => 1}, [:a])\n    %{a: 1}\n\n    iex> JetExt.Map.indifferent_take(%{\"a\" => 1}, [:b])\n    %{}","ref":"JetExt.Map.html#indifferent_take/2-example"},{"type":"function","title":"JetExt.Map.indifferent_update!/3","doc":"Indifferent updates the key in map with the given function.\n\nIf `key` is not present in `map`, a `KeyError` exception is raised.","ref":"JetExt.Map.html#indifferent_update!/3"},{"type":"function","title":"Example - JetExt.Map.indifferent_update!/3","doc":"iex> JetExt.Map.indifferent_update!(%{a: 1}, :a, fn val -> val + 1 end)\n    %{a: 2}\n\n    iex> JetExt.Map.indifferent_update!(%{\"a\" => 1}, :a, fn val -> val + 1 end)\n    %{\"a\" => 2}\n\n    iex> JetExt.Map.indifferent_update!(%{\"a\" => 1}, :b, fn val -> val + 1 end)\n    ** (KeyError) key :b and \"b\" not found in: %{\"a\" => 1}","ref":"JetExt.Map.html#indifferent_update!/3-example"},{"type":"function","title":"JetExt.Map.put_field/3","doc":"Put a value to map base on key type of the map.\n\n    iex> JetExt.Map.put_field(%{a: 1, b: 2}, :c, 3)\n    %{a: 1, b: 2, c: 3}\n\n    iex> JetExt.Map.put_field(%{\"a\" => 1, \"b\" => 2}, :c, 3)\n    %{\"a\" => 1, \"b\" => 2, \"c\" => 3}\n\n    iex> JetExt.Map.put_field(%{\"a\" => 1, b: 2}, :c, 3)\n    ** (ArgumentError) expected map to be a map with atoms or string keys, got a map with mixed keys: %{:b => 2, \"a\" => 1}","ref":"JetExt.Map.html#put_field/3"},{"type":"function","title":"JetExt.Map.recursive_atomize_keys/1","doc":"Atomize keys of any map nested in the term recursively.","ref":"JetExt.Map.html#recursive_atomize_keys/1"},{"type":"function","title":"Example - JetExt.Map.recursive_atomize_keys/1","doc":"iex> JetExt.Map.recursive_atomize_keys(%{\"a\" => 1, \"b\" => 2})\n    %{a: 1, b: 2}\n    iex> JetExt.Map.recursive_atomize_keys(%{\"a\" => 1, \"b\" => %{\"c\" => 2}})\n    %{a: 1, b: %{c: 2}}\n    iex> JetExt.Map.recursive_atomize_keys(%{\"a\" => [%{\"b\" => %{\"c\" => 2}}]})\n    %{a: [%{b: %{c: 2}}]}\n    iex> JetExt.Map.recursive_atomize_keys(%{\"a\" => [%{\"b\" => %{\"c\" => 2}}], d: true})\n    %{a: [%{b: %{c: 2}}], d: true}\n    iex> JetExt.Map.recursive_atomize_keys([%{\"a\" => 1}, \"b\"])\n    [%{a: 1}, \"b\"]","ref":"JetExt.Map.html#recursive_atomize_keys/1-example"},{"type":"function","title":"JetExt.Map.stringify_keys/1","doc":"Stringify keys of map.","ref":"JetExt.Map.html#stringify_keys/1"},{"type":"function","title":"Example - JetExt.Map.stringify_keys/1","doc":"iex> JetExt.Map.stringify_keys(%{a: 1, b: 2})\n    %{\"a\" => 1, \"b\" => 2}\n    iex> JetExt.Map.stringify_keys(%{a: 1, b: %{c: 2}})\n    %{\"a\" => 1, \"b\" => %{c: 2}}","ref":"JetExt.Map.html#stringify_keys/1-example"},{"type":"module","title":"JetExt.Plug.SDL","doc":"A plug for serving sdl file.\n\nIt requires one option:\n- `schema`: the Absinthe.Schema module.\n\n```elixir\nforward \"/graphql.sdl\", JetExt.Plug.SDL,\n  schema: MyGraphQL.Schema\n```","ref":"JetExt.Plug.SDL.html"},{"type":"module","title":"JetExt.Types","doc":"Define types that used in the jet projects.","ref":"JetExt.Types.html"},{"type":"function","title":"JetExt.Types.make_module_sum_type/2","doc":"Make sum type from a list of modules.\n\n  ```elixir\n  defmodule Foo do\n    @type t() :: :foo\n  end\n  defmodule Bar do\n    @type t() :: :bar\n  end\n  defmodule Baz do\n    @type t() :: :baz\n  end\n  ```\n\n    iex> JetExt.Types.make_module_sum_type([Foo, Bar, Baz], :t)","ref":"JetExt.Types.html#make_module_sum_type/2"},{"type":"function","title":"JetExt.Types.make_sum_type/1","doc":"Make [sum type](https://en.wikipedia.org/wiki/Tagged_union).\n\n    iex> JetExt.Types.make_sum_type([:foo, :bar, :baz])\n    quote do :foo | :bar | :baz end","ref":"JetExt.Types.html#make_sum_type/1"},{"type":"type","title":"JetExt.Types.as_required/1","doc":"Used to declare the key of a `Keyword` as mandatory.\n\nNOTE: It can only be used on the type of the value.\n\n```elixir\n@type options() :: [\n  required_key: as_required(boolean()),\n  optional_key: boolean()\n]\n```","ref":"JetExt.Types.html#t:as_required/1"},{"type":"type","title":"JetExt.Types.maybe/1","doc":"","ref":"JetExt.Types.html#t:maybe/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}